import java.applet.*;
import java.awt.*;
import java.awt.event.*;

/*<applet code="DrawApplet" width=400 height=400></applet>*/


public class DrawApplet extends Applet implements ActionListener, ItemListener, TextListener{
	MyCanvas	canvas;						// LoX
	ColorCanvas	clrCanvas;					// J[{LoX
	TextField	txtField;					// eLXgtB[h
	TextField	txR,txG,txB;				// J[l̓tB[h
	Color		clr;						// J[l
	DrawAbout	abt;

	public void init(){
		abt = null;
		Dimension	dem	= getSize();						// Avbg̃TCY
		Dimension	canvasDem	= new Dimension();
		Choice		choice		= new Choice ();			// R}h
		Choice		fill		= new Choice();				// 
		Button		buttonUndo	= new Button ("Undo");		// undo{^
		Button		buttonClear	= new Button ("Clear");		// NA{^
		Button		buttonAbout	= new Button ("About");		// AoEg{^
		clr		  = new Color(0,0,0);						// J[lftHgF
		clrCanvas = new ColorCanvas(clr);					// F{
		canvas    = new MyCanvas();							// LoX
		int wd = 50;

		txtField  = new TextField(wd);						// eLXgtB[h
		txR = new TextField(5);						// J[l̓tH[h֘A
		txG = new TextField(5);
		txB = new TextField(5);
		txR.setText("0");
		txG.setText("0");
		txB.setText("0");
		txR.addTextListener(this);
		txG.addTextListener(this);
		txB.addTextListener(this);
		Label space = new Label("          ");
		Label	lbR = new Label("R:");
		Label	lbG = new Label("G:");
		Label	lbB = new Label("B:");				// ܂


		choice.addItem("");						// XgpACe
		choice.addItem("`");
		choice.addItem("~");
		choice.addItem("ȉ~");
		choice.addItem("O");
		choice.addItem("eLXg");
		choice.addItemListener(this);
		fill.addItem("̂");
		fill.addItem("");
		fill.addItem("hԂ");
		fill.addItemListener(this);					// ܂

		buttonUndo.addActionListener(this);		// {^̃Xi[
		buttonClear.addActionListener(this);
		buttonAbout.addActionListener(this);	
		txtField.addTextListener(this);				// ܂

		canvasDem.width  = Math.max(400,dem.width) ;
		canvasDem.height = Math.max(200,dem.height-50);
		canvas.setSize(canvasDem.width, canvasDem.height);		// LoX̃TCY

		clrCanvas.setSize(15,15);			// F{LoX̃TCY
		add(choice);						// R}hǉ
		add(fill);							// R}hǉ
		add(clrCanvas);						// F{LoX
		add(buttonUndo);					// Undoǉ
		add(buttonClear);					// Clearǉ
		add(buttonAbout);					// J[_CAOǉ
		add(txtField);						// eLXgtB[hǉ
		add(space);							// Xy[Xx
		add(lbR);	add(txR);				// J[͗p
		add(lbG);	add(txG);				// J[͗p
		add(lbB);	add(txB);				// J[͗p
		add(canvas);						// h[GAǉ

		canvas.itemChanged("MyLine");		// ftHgMyLine
	}

	public void actionPerformed(ActionEvent ae){
		String cmd = ae.getActionCommand();				// {^̏
		if ( cmd.equals("Undo") )			canvas.undo();
		else if ( cmd.equals("Clear"))		canvas.clear();
		else if ( cmd.equals("About") && abt == null){
			abt = new DrawAbout(this, getAppletContext());
			abt.show();
			abt.setSize(300,150);
		}
	}

	protected void eraseAbout(){
		abt = null;
	}

	public void itemStateChanged(ItemEvent ie){			// XgύXꂽ
		String	cmd = ((Choice)ie.getItemSelectable()).getSelectedItem();	// canvasɒʒm
		canvas.itemChanged(cmd);
	}

	public void textValueChanged(TextEvent te){			// eLXgtB[hύXꂽꍇ
		try{
			clr = new Color(Integer.decode(txR.getText()).intValue(),
						Integer.decode(txG.getText()).intValue(),
						Integer.decode(txB.getText()).intValue());
			clrCanvas.setColor(clr);
			canvas.setColor(clr);
		}
		catch(Exception e){}

		String msg = txtField.getText();				// eLXgpeLXg
		if ( msg.equals("") )
			return;
		if ( canvas.setString(msg) == false)
			txtField.setText("");						// ܂
	}
}
